//
// DeleteDirectory.cpp
//
// Written by Nobuki HIRAMINE
// Last modified : 2007/04/14
//
#include "stdafx.h"
#include <afxwin.h>

BOOL DeleteDirectory( LPCTSTR lpPathName )
{
	// ͒l`FbN
	if( NULL == lpPathName )
	{
		return FALSE;
	}

	// fBNg̕ۑiI['\'ȂȂtj
	TCHAR szDirectoryPathName[_MAX_PATH];
	_tcsncpy_s( szDirectoryPathName, _MAX_PATH, lpPathName, _TRUNCATE );
	if( '\\' != szDirectoryPathName[_tcslen(szDirectoryPathName) - 1] )
	{	// ԍŌ'\'ȂȂtB
		_tcsncat_s( szDirectoryPathName, _MAX_PATH, _T("\\"), _TRUNCATE );
	}

	// fBNg̃t@Cp̃t@C쐬
	TCHAR szFindFilePathName[_MAX_PATH];
	_tcsncpy_s( szFindFilePathName, _MAX_PATH, szDirectoryPathName, _TRUNCATE );
	_tcsncat_s( szFindFilePathName, _MAX_PATH, _T("*"), _TRUNCATE );

	// fBNg̃t@CJn
	WIN32_FIND_DATA		fd;
	HANDLE hFind = FindFirstFile( szFindFilePathName, &fd );
	if( INVALID_HANDLE_VALUE == hFind )
	{	// ΏۃtH_݂ȂB
		return FALSE;
	}

	do
	{
		//if( '.' != fd.cFileName[0] )
		if( 0 != _tcscmp( fd.cFileName, _T(".") )		// JgtH_u.v
		 && 0 != _tcscmp( fd.cFileName, _T("..") ) )	// etH_u..v́AXLbv
		{
			TCHAR szFoundFilePathName[_MAX_PATH];
			_tcsncpy_s( szFoundFilePathName, _MAX_PATH, szDirectoryPathName, _TRUNCATE );
			_tcsncat_s( szFoundFilePathName, _MAX_PATH, fd.cFileName, _TRUNCATE );

			if( FILE_ATTRIBUTE_DIRECTORY & fd.dwFileAttributes )
			{	// fBNgȂċNĂяoō폜
				if( !DeleteDirectory( szFoundFilePathName ) )
				{
					FindClose( hFind );
					return FALSE;
				}
			}
			else
			{	// t@CȂWin32API֐pč폜
				if( !DeleteFile( szFoundFilePathName ) )
				{
					FindClose( hFind );
					return FALSE;
				}
			}
		}
	} while( FindNextFile( hFind, &fd ) );

	FindClose( hFind );

	return RemoveDirectory( lpPathName );
}

BOOL DeleteDirectoryUseShellFunc( LPCTSTR lpPathName )
{
	// ͒l`FbN
	if( NULL == lpPathName )
	{
		return FALSE;
	}

	// fBNg̕ۑiI[A"\0\0"ɂj
	TCHAR szDirectoryPathName[_MAX_PATH];
	_tcsncpy_s( szDirectoryPathName, _MAX_PATH, lpPathName, _TRUNCATE );
	if( '\\' == szDirectoryPathName[_tcslen(szDirectoryPathName) - 1] )
	{	// ԍŌ'\'Ȃ苎B
		szDirectoryPathName[_tcslen(szDirectoryPathName) -1] = '\0';
	}
	szDirectoryPathName[_tcslen(szDirectoryPathName) + 1] = '\0';

	SHFILEOPSTRUCT fos;
	ZeroMemory( &fos, sizeof(SHFILEOPSTRUCT) );
	fos.hwnd	= NULL;
	fos.wFunc	= FO_DELETE;
 	fos.pFrom	= szDirectoryPathName;
	fos.fFlags	= FOF_NOCONFIRMATION | FOF_NOERRORUI | FOF_SILENT; // | FOF_ALLOWUNDO;
	if( SHFileOperation( &fos ) )
	{	// ƂOAsƂOȊOԂB
		return FALSE;
	}
	return TRUE;
}

